Subject: bug#5771: 23.1; compile command with cd to new dir

From: Kevin Ryde <[email-masked]>
Date: Fri, 26 Mar 2010 09:27:07 +1100

Evaluating

    (compile "mkdir /tmp/newdir;\n cd /tmp/newdir;\n echo hi")

gets an emacs error

    => /tmp/newdir/: no such directory

and doesn't run the command.  I hoped that no matter what the command
string contains that emacs would start it.

I suppose `compilation-start' attempts to set default-directory to the
cd it sees, but doesn't notice the command itself will create it.

A similar thing happens if you've got a hairy shell expression in the
cd,

    (compile "cd ${FOO:-${BAR}};\n echo hi")

    => emacs error

I suppose in this case the expression is more than substitute-env-vars
understands.

I think if the apparent directory in a command doesn't exist then
compilation-start shouldn't try to use it.

In GNU Emacs 23.1.1 (i486-pc-linux-gnu, GTK+
Version 2.16.5)
 of 2009-09-14 on raven, modified by Debian
configured using `configure  '--build=i486-linux-gnu' '--host=i486-linux-gnu' '--prefix=/usr' '--sharedstatedir=/var/lib' '--libexecdir=/usr/lib' '--localstatedir=/var/lib' '--infodir=/usr/share/info' '--mandir=/usr/share/man' '--with-pop=yes' '--enable-locallisppath=/etc/emacs23:/etc/emacs:/usr/local/share/emacs/23.1/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/23.1/site-lisp:/usr/share/emacs/site-lisp:/usr/share/emacs/23.1/leim' '--with-x=yes' '--with-x-toolkit=gtk' '--with-toolkit-scroll-bars' 'build_alias=i486-linux-gnu' 'host_alias=i486-linux-gnu' 'CFLAGS=-DDEBIAN -g -O2' 'LDFLAGS=-g' 'CPPFLAGS=''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: nil
  value of $LC_MESSAGES: nil
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: en_AU
  value of $XMODIFIERS: nil
  locale-coding-system: iso-latin-1-unix
  default-enable-multibyte-characters: t